// Blank lines and comments stripped to reduce size.
// Contact contact@SpiritAndTruth.org for commented source files.
function Book( title, files )
    {
    this._title = title;
    this._files = files;
    this._reader;
    this._xLast;
    this._prevAddressAnchor;
    this._prevTopic;
    this._prevNumber;
    this._prevPrefix;
    this._goMoved = true;
    this._pane = undefined;
    this._seek;
    this._seekPane;
    this._sought;
    this._seekUnderway = false;
    this._prevFile = undefined;
    this._isLoaded = false;
    this._searchBinary = false;
    this._urlDir;
    this._onLoadUsed = true
    }
new Book();
Book.prototype.onLoadUsed = function() 
    {
    return this._onLoadUsed;
    }
Book.prototype.setOnLoadUsed = function( onLoadUsed ) 
    {
    this._onLoadUsed = onLoadUsed;
    }
Book.prototype.setTitle = function( title ) 
    {
    this._title = title;
    }
Book.prototype.reader = function( reader ) 
    {
    this._reader = reader;
    }
Book.prototype.searchBinary = function( isBinary )
    { 
    this._searchBinary = isBinary
    }
Book.prototype.file = function( name ) 
    { 
    return this._files[ name ];
    }
Book.prototype.urlDir = function() 
    { 
    return this._urlDir;
    }
Book.prototype.setUrlDir = function( dir ) 
    {
    this._urlDir = dir;
    }
Book.prototype.setPrevTopic = function( topic ) 
    {
    this._prevTopic = topic;
    }
Book.prototype.setPane = function( pane ) 
    {
    this._pane = pane;
    }
Book.prototype.title = function() 
    { 
    return this._title;
    }
Book.prototype.linker = function() 
    { 
    return this._linker;
    }
Book.prototype.pane = function() 
    { 
    return this._pane;
    }
Book.prototype.issueLinkTip = function()
    {
    top.status = 'Click twice on same address to move this book with others.'
    return;
    if ( wlx.wlx_linkTipGiven == undefined )
        {
        alert( '* The FIRST click moves other unlocked columns to the underlined location.\n* The SECOND click causes this column to follow.' )
        wlx.wlx_linkTipGiven = true
        }
    }
Book.prototype.openUrl = function( topic, pane ) 
    { 
    var goTo = undefined
    if ( topic.substring( 0, 5 ) == 'http:' )
        {
        goTo = topic
        }
    else if ( topic.substring( 0, 6 ) == 'https:' )
        {
        goTo = topic
        }
    else if ( topic.substring( 0, 4 ) == 'www.' )
        {
        goTo = 'https://' + topic
        }
    else if ( topic.substring( 0, 5 ) == 'file:' )
        {
        goTo = topic
        }
    else if ( topic.substring( 0, 4 ) == 'ftp:' )
        {
        goTo = topic
        }
    else if ( topic.substring( 0, 1 ) == '\\' )
        {
        goTo = topic
        }
    else if ( topic.substring( 0, 1 ) == '\.' )
        {
        topic = '../xref/xlinx/' + topic
        goTo = topic
        }
    if ( goTo != undefined )
        {
        top.location.href = goTo
        }
    return ( goTo != undefined )
    }
Book.prototype.BOOK_goAddress = function( address, pane ) 
    { 
    this._goMoved = false;
    var forward = true;
    var contained = this._reader.containsViewer( pane )
    if ( contained && 1 < this._reader.numReaders() )
        {
        this.issueLinkTip();
        var anchor = address.anchor()
        if ( anchor == this._prevAddressAnchor )
            {
            forward = this.goAddressUnconditional( address, pane );
            }
        this._prevAddressAnchor = address.anchor();
        }
    else
        {
        forward = this.goAddressUnconditional( address, pane );
        }
    return forward;
    }
Book.prototype.BOOK_goTopic = function( topic, pane ) 
    { 
    this._goMoved = false;
    var forward = true

    if ( this.openUrl( topic, pane ) )
        {
        return true
        }
    if ( topic == Reader.INTRODUCTION && this._prevTopic != topic )
        {
        this.goHelp()
        return false
        }
    if ( this._reader.containsViewer( pane ) && 1 < this._reader.numReaders() )
        {
        if ( true || topic == this._prevTopic )
            {
            forward = this.goTopicUnconditional( topic, pane );
            }
        this._prevTopic = topic;
        }
    else
        {
        forward = this.goTopicUnconditional( topic, pane );
        }
    return forward;
    }
Book.prototype.BOOK_goFootnote = function( topic, pane ) 
    { 
    this._goMoved = false;
    var forward = true

    // Let book handle footnote, if supports it.
    if ( (undefined != this.goFootnoteUnconditional) && 
        this.goFootnoteUnconditional( topic ) ) 
        {
        this._goMoved = true;
        forward = false
        }
    return forward;
    }

Book.prototype.BOOK_goStrongs = function( prefix, number, pane ) 
    { 
    this._goMoved = false;
    if ( this._reader.containsViewer( pane ) && 1 < this._reader.numReaders() )
        {
        if ( true || prefix == this._prevPrefix )
            {
            return this.goStrongsUnconditional( prefix, number, pane );
            }
        this._prevNumber = number;
        this._prevPrefix = prefix;
        }
    else
        {
        return this.goStrongsUnconditional( prefix, number, pane );
        }
    return true;
    }
Book.prototype.seekInLoadedFile = function( fullPath, pane )
    {
    if ( this._seekUnderway )
        {
        return;
        }
    this._seekUnderway = true;
    var pathAndAnchor = fullPath.split( '#' );
    var path = pathAndAnchor[ 0 ];
    if ( pathAndAnchor[ 2 ] !== undefined )
        {
        pathAndAnchor[ 1 ] = pathAndAnchor[ 1 ] + '#' + pathAndAnchor[ 2 ]
        pathAndAnchor[ 2 ] = undefined
        anchor = undefined
        }
    var file = path.match( '[^\/]+$' )[ 0 ]
    var newPath = pane.location.href 
    newPath = newPath.split( '#' );
    newPath = newPath[ 0 ]
    var newFile = newPath.match( '[^\/]+$' )[ 0 ]
    if ( newFile == file ) 
        {
            
        var useAnchor = pathAndAnchor[ 1 ];
        if ( anchor != undefined )
            {
            anchor = this.anchorForCompare( useAnchor )
            var doc = pane.document;
            var anchors = doc.anchors;
            if ( 0 < anchors.length )
                {
                var bestMatch = 0;
                var bestIndex = 0;
                var BIGDISTANCE = 1000
                var bestDistance = BIGDISTANCE
                var bestLength = BIGDISTANCE
                if ( !this._searchBinary )
                    {
                    for ( var iA = 0 ; iA < anchors.length ; ++iA )
                        {
                        var aName = this.anchorForCompare( anchors[ iA ].name )
                        var match = 0;
                        var distance = BIGDISTANCE
                        var length = anchor.length
                        if ( aName.length < length )
                            {
                            length = aName.length
                            }
                        for ( var iT = 0 ; iT < length ; ++iT )
                            {
                            nameCode = aName.charCodeAt( iT )
                            anchorCode = anchor.charCodeAt( iT )
                            if ( nameCode != anchorCode )
                                {
                                distance = anchorCode - nameCode
                                break;
                                }
                            match++;
                            }
                        if ( 
                            ( bestMatch < match )
                            ||
                            ( bestMatch == match && 0 <= distance && distance < bestDistance )
                            )
                            {
                            bestDistance = distance
                            bestMatch = match;
                            bestIndex = iA;
                            if ( bestMatch == anchor.length  && bestMatch == aName.length )
                                {
                                break;
                                }
                            }
                        }
                    }
                else
                    {
                    var iBot = 0
                    var iTop = anchors.length
                    while ( iBot != iTop )
                        {
                        var span = iTop - iBot
                        var remainder = ( span % 2 ) / 2
                        var delta = ( span / 2 ) - remainder
                        if ( delta == 0 ) break
                        var iA = iBot + delta
                        var aName = this.anchorForCompare( anchors[ iA ].name )
                        var match = 0;
                        var distance = BIGDISTANCE
                        var length = anchor.length
                        if ( aName.length < length )
                            {
                            length = aName.length
                            }
                        for ( var iT = 0 ; iT < length ; ++iT )
                            {
                            nameCode = aName.charCodeAt( iT )
                            anchorCode = anchor.charCodeAt( iT )
                            if ( nameCode != anchorCode )
                                {
                                distance = anchorCode - nameCode
                                break;
                                }
                            match++;
                            }
                        if ( 
                            ( bestMatch < match )
                            ||
                            ( bestMatch == match && 0 <= distance && distance <= bestDistance )
                            )
                            {
                            bestDistance = distance
                            bestMatch = match;
                            bestIndex = iA;
                            if ( bestMatch == anchor.length && bestMatch == aName.length )
                                {
                                break;
                                }
                            }
                        if ( distance < 0  || distance == BIGDISTANCE )
                            {
                            iTop = iA
                            }
                        else
                            {
                            iBot = iA
                            }
                        }
                    }
                if ( bestMatch !== undefined )
                    {
                    useAnchor = anchors[ bestIndex ].name;
                    }
                }
            }
            if ( useAnchor != '' && useAnchor !== undefined )
                {
                var url = path + '#' + useAnchor
                pane.location.href = url
                }
        }
    else
        {
        }
    this._seekUnderway = false;
    }
Book.prototype.anchorForCompare = function( anchor )
    { 
    if ( anchor != undefined )
        {
        anchor = anchor.toLowerCase();
        var isNumeric = anchor.search( /\d/ )
        if ( -1 != isNumeric  )
            {
            var was;
            do
                {
                was = anchor
                anchor = anchor.replace( /(\D)(\d)(\D)/g, '$1 00$2$3' )
                anchor = anchor.replace( /(\D)(\d)$/g, '$1 00$2' )
                anchor = anchor.replace( /(\D)(\d\d)(\D)/g, '$1 0$2$3' )
                anchor = anchor.replace( /(\D)(\d\d)$/g, '$1 0$2' )
                }
            while( was != anchor )
            }
        if ( was != anchor )
            {
            }
        }
    return anchor
    }
Book.prototype.goAddressUnconditional = function( address, pane ) 
    { 
    return true;
    }
Book.prototype.goTopicUnconditional = function( topic, pane ) 
    { 
    return true;
    }
Book.prototype.goStrongsUnconditional = function( prefix, number, pane ) 
    { 
    return true;
    }
Book.prototype.goMoved = function( )
    { 
    return this._goMoved;
    }
Book.prototype.setGoMoved = function( moved )
    { 
    this._goMoved = moved;
    }
Book.prototype.onLoad = function( pane ) 
    { 
    this.BOOK_onLoad( pane )
    }
Book.prototype.BOOK_onLoad = function( pane ) 
    { 
    if ( pane == this.pane() )
        {
        this._isLoaded = true
        }
    if ( this.onLoadUsed() && this._seek != undefined )
        {
        var useSeek = this._seek
        this._seek = undefined
        this.seekInLoadedFile( useSeek, this._seekPane );
        }
    }
Book.prototype.setIsLoaded = function( isLoaded ) 
    { 
    this._isLoaded = isLoaded
    }
Book.prototype.isLoaded = function() 
    { 
    return this._isLoaded
    }
Book.prototype.goFile = function( fileWithAnchor, pane ) 
    {
    if ( -1 != fileWithAnchor.search( /#__/ ) )
        {
        return;
        }
    if ( pane == undefined )
        {
        pane = this.pane()
        }
    var fullPath = fileWithAnchor;
    var fullUrl = fullPath.search( /:\/\// )
    if ( -1 == fullUrl )
        {
        fullPath = this.urlDir() + fullPath
        }
    if ( this._seek == fullPath && this._seekPane == pane )
        {
        return;
        }
    this._seek = fullPath
    this._seekPane = pane
    this._goMoved = true;
    fileAndAnchor = fileWithAnchor.split( '#' )
    file = fileAndAnchor[ 0 ]
    anchor = fileAndAnchor[ 1 ] 
    paneName = ''
    if ( wlx.wlx_NetBible_TITLE != this.title() || wlx.wlx_NetBibleLocal )
        {
        paneName = pane.name
        }
    pane.location.href = fullPath
    var prevFile = this._prevFile
    this._prevFile = file;
    if ( prevFile == file && this.onLoadUsed() )
        {
        this.onLoad( pane )
        }
    }
Book.prototype.goTopic = function( topic, pane ) 
    { 
    return this.BOOK_goTopic( topic, pane )
    }
Book.prototype.goFootnote = function( topic, pane ) 
    { 
    return this.BOOK_goFootnote( topic, pane )
    }
Book.prototype.goAddress = function( topic, pane ) 
    { 
    return this.BOOK_goAddress( topic, pane )
    }
Book.prototype.goStrongs = function( prefix, number, pane ) 
    { 
    return this.BOOK_goStrongs( prefix, number, pane )
    }
Book.prototype.goHelp = function()
    {
    }
Book.prototype.goIndex = function()
    {
    }
Book.prototype.goCancel = function()
    {
    }
Book.prototype.goSearch = function( 
    title,
    target,
    isCase,
    isShow,
    isExp,
    isOT,
    isNT
    ) 
    {
    return this.BOOK_goSearch( 
        title,
        target,
        isCase,
        isShow,
        isExp,
        isOT,
        isNT
        )
    }
Book.prototype.BOOK_goSearch = function( 
    title,
    target,
    isCase,
    isShow,
    isExp,
    isOT,
    isNT
    ) 
    { 
    alert(
        'Book.goSearch\n' +
        'title ' + title + '\n' +
        'target ' + target  + '\n' +
        'isCase' + isCase + '\n' +
        'isShow' +  isShow + '\n' +
        'isExp ' + isExp + '\n' +
        'isOT ' + isOT + '\n' +
        'isNT ' + isNT + '\n' +
        'NOT YET AVAILABLE!'
        )
    }
