// Blank lines and comments stripped to reduce size.
// Contact contact@SpiritAndTruth.org for commented source files.
function Linker ( pane )
    {
    if ( wlx.wlx_linkerPath === undefined && pane !== undefined )
        {
	wlx.wlx_linkerPath = wlx.wlx_getUrlDir( pane )
	}
    this._path = wlx.wlx_linkerPath
    this._xrefActive = false;
    this._pane = pane ;
    this._minReaders = 1;
    this._maxReaders = 8;
    this._readers = new Array();
    this._topPane;
    this._form;
    this._prefix;
    this._number;
    this._addressableRequestor;
    
    var appName = navigator.appName;
    var split = appName.split( ' ' );
    this._isMicrosoft = ( split[ 0 ] == 'Microsoft' );
    }
new Linker();
wlx.wlx_getUrlDir = function( pane )
    {
    var urlDir;
    if ( pane !== undefined && pane.location !== undefined )
        {
        urlDir = pane.location.href
        var lastSlash = urlDir.lastIndexOf( '\/', urlDir.length )
        if ( -1 == lastSlash )
            {
            lastSlash = urlDir.lastIndexOf( '\\', urlDir.length )
            }
        if ( -1 != lastSlash )
            {
            urlDir = urlDir.substring( 0, lastSlash + 1 )
            }
        }
    return urlDir
    }
Linker.prototype.register = function( reader )
    {
    this._readers[ this._readers.length ] = reader;
    }
Linker.prototype.isMicrosoft = function()
    {
    return this._isMicrosoft;
    }
Linker.prototype.numReaders = function( reader )
    {
    return this._readers.length;
    }
Linker.prototype.getReaders = function()
    {
    return this._readers
    }
Linker.prototype.openBooks = function()
    {
    var open = new Array();
    for ( var i = 0 ; i < this.numReaders() ; ++i )
        {
        var reader = this._readers[ i ];
        open[ open.length ] = reader.title();
        }
    return open;
    }
Linker.prototype.parseTopic = function( topic ) 
    {
    topic = topic.replace( /^\s+/, '' );
    if ( topic.length == 0 )
        {
        topic = undefined
        }
    return topic
    }
Linker.prototype.xref = function( topicAndBooks, pane, alone ) 
    {
    if ( alone == undefined )
        {
        alone = false
        }
    if ( this._xrefActive )
        {
        return;
        }
    var isChapterButton = false
    var pieces = topicAndBooks.split( '|' )
    var ids = undefined
    if ( 1 < pieces.length )
        {
        ids = pieces[ 1 ]
        }
    topic = pieces[ 0 ]
    topic = this.parseTopic( topic )
    var chapterFile = topic.match( /^[Bb][0-9][0-9][Cc][0-9][0-9][0-9]$/ )
    if ( chapterFile )
        {
        var bookNumber = topic.substring( 1, 3 ) * 1.0;
        var chapterNumber = topic.substr( 4, 7 ) * 1.0;
        var addr = new Address();
        addr.setLocation( bookNumber, chapterNumber, 1 );
        if ( ids == 'BOT' )
            {
            var lastVerse = addr.verses()
            addr.setLocation( bookNumber, chapterNumber, lastVerse );
            }
        topic = addr.anchor()
        ids = undefined
        isChapterButton = true
        }
    if ( topic == undefined )
        {
        return;
        }
    var address = new Address( topic );
    var isAddr = address.isValid();
    var isStrongs = this.isStrongs( topic )
    var isFootnote = (-1 != topic.search( /#/ ))
    var isTopic = (!isStrongs && !isAddr && !isFootnote)
    var forward = true;
    var srcReader;
    for ( var i = 0 ; i < this.numReaders() ; ++i )
        {
        var child = this._readers[ i ];
        if ( child.containsPane( pane ) )
            {
            srcReader = child;
            if ( isAddr )
                {
                forward = child.goAddress( address, pane, alone );
                }
            else if ( isStrongs )
                {
                forward = child.goStrongs( this._prefix, this._number, pane, alone );
                }
            else if ( isFootnote )
                {
                forward = child.goFootnote( topic, pane, alone );
                }
            else
                {
                forward = child.goTopic( topic, pane, alone );
                }
            break;
            }
        }
    if ( forward && !alone )
        {
        for ( var i = 0 ; i < this.numReaders() ; ++i )
            {
            var child = this._readers[ i ];
            if ( child === srcReader )
                {
                continue;
                }
            if ( isAddr )
                {
                forward = child.goAddress( address, pane );
                }
            else if ( isStrongs )
                {
                forward = child.goStrongs( this._prefix, this._number, pane, alone );
                }
            else
                {
                forward = child.goTopic( topic, pane );
                }
            }
        }
    if ( this._addressableRequestor != undefined )
        {
        addressableOpen = false
        for ( var i = 0 ; !addressableOpen && i < this.numReaders() ; ++i )
            {
            var child = this._readers[ i ];
            addressableOpen = (
                child.isAddressable() && 
                child.title() != this._addressableRequestor
                )
            }
        this._addressableRequestor = undefined
        }
    if ( !alone )
        {
        if ( ids !== undefined )
            {
            var present = false
            for ( var i = 0 ; !present && i < this._readers.length ; ++i )
                {
                var index = ids.indexOf( this._readers[ i ].id() ) 
                present = ( 0 <= index )
                }
            if ( !present )
                {
                this.addBook( Reader.titleFromID( ids ), topic, pane )
                }
            }
        else {
            var addressableOpen = false
            var topicalOpen = false
            var strongableOpen = false
            for ( var i = 0 ; i < this.numReaders() ; ++i )
                {
                var child = this._readers[ i ];
                if  ( child.isTopical() )
                    {
                    topicalOpen = true
                    }
                if  ( child.isAddressable() )
                    {
                    addressableOpen = true
                    }
                if  ( child.isStrongable() )
                    {
                    strongableOpen = true
                    }
                }
            if ( isAddr && !addressableOpen )
                {
                this.addBook( wlx.wlx_KjvsBible_TITLE, address.anchor(), pane )
                }
            else if ( isStrongs && !strongableOpen )
                {
                this.addBook( wlx.wlx_Bdb_TITLE, topic, pane )
                }
            else if ( isTopic && !topicalOpen  && ( srcReader.title() != wlx.wlx_Help_TITLE ) )
                {
                this.addBook( wlx.wlx_Naves_TITLE, topic, pane )
                }
            }
        }
    if ( isChapterButton )
        {
        this.xref( topic, pane, true ) 
        }
    }
Linker.prototype.requestAddressableBook = function( requestingTitle )
    {
    this._addressableRequestor = requestingTitle
    }
Linker.prototype.onLoad = function( pane ) 
    {
    for ( var i = 0 ; i < this.numReaders() ; ++i )
        {
        var child = this._readers[ i ];
        if ( child.containsPane( pane ) )
            {
            child.onLoad( pane );
            }
        }
    }
Linker.prototype.unregister = function( reader ) 
    {
    for ( var i = 0 ; i < this.numReaders() ; ++i )
        {
        var child = this._readers[ i ];
        if  (child == reader )
            {
            first = this._readers.slice( 0, i )
            last = this._readers.slice( i + 1, this._readers.length )
            this._readers = first.concat( last )
            break
            }
        }
    }
Linker.prototype.onMaximize = function( pane ) 
    {
    if ( this._readers.length == 1 )
        {
        return
        }
    for ( i = 0 ; i < this._readers.length ; ++i )
        {
        reader = this._readers[ i ];
        if ( reader.containsPane( pane ) )
            {
            this._readers[ 0 ] = this._readers[ i ]
            this._readers[ 0 ].setSeekLast( this._readers[ i ].seekLast() )
            wlx.wlx_columns = 2
            this.onMinus( 1 )
            }
        }
    }
Linker.prototype.onClose = function( pane ) 
    {
    columns = this._readers.length
    for ( i = 0 ; i < columns ; ++i )
        {
        reader = this._readers[ i ];
        if ( reader.containsPane( pane ) )
            {
            for ( n = i ; n < columns - 1 ; ++n )
                {
                this._readers[ n ] = this._readers[ n + 1 ]
                this._readers[ n ].setSeekLast = this._readers[ n + 1 ].seekLast()
                }
            }
        }
    this.onMinus()
    }
Linker.prototype.onPlus = function( title, topic, cols ) 
    {
    if ( this.numReaders() < this._maxReaders )
        {
        if ( cols === undefined )
            {
            cols = this.numReaders() + 1;
            }
        wlx.wlx_columns = cols
        if ( wlx.wlx_maxColumns != 'AUTO' )
            {
            wlx.wlx_linker.setColumnSelection( wlx.wlx_columns )
            }
        this.restart( title, topic )
        wlx.wlx_columns = cols
        }
    }
Linker.prototype.onMinus = function( cols ) 
    {
    if ( wlx.wlx_columns == this._minReaders )
        {
        return
        }
    if ( cols === undefined )
        {
        cols = this.numReaders() - 1;
        }
    this._readers.length = cols
    wlx.wlx_columns = cols
    if ( wlx.wlx_maxColumns != 'AUTO' )
        {
        this.setColumnSelection( cols )
        }
    this.restart()
    }
Linker.prototype.restart = function( title, topic ) 
    {
    wlx.wlx_saveStateToCookie( title, topic )
    var file = 'linker' + wlx.wlx_columns.toString() + '.htm';
    var path = this._path + file
    this._pane.location.href = path;
    wlx.wlx_decodeArgs()
    }
Linker.prototype.onHome = function() 
    {
    wlx.wlx_saveStateToCookie()
    top.document.location.href = '../index.htm'
    }
Linker.prototype.onFonts = function() 
    {
    wlx.wlx_saveStateToCookie()
    window.open( '../fontsu/index.htm' )
    }
Linker.prototype.onHelp = function() 
    {
    this.addBook( wlx.wlx_Help_TITLE, "" )
    }
Linker.prototype.isStrongs = function( topic )
    {
    var topicLower = topic.toLowerCase()
    prefix = topicLower.charAt( 0 )
    if ( prefix == 'g' || prefix == 'h' )
        {
        var max = 8853
        if ( prefix == 'g' )
            {
            max = 5899
            }
        var begin = topicLower.search( /\d+/ )
        if ( 1 == begin )
            {
            var front = topicLower.substring( begin, topicLower.length )
            var end = front.search( /\D+/ )
            if ( -1 == end )
                {
                end = front.length
                }
            var number = front.substring( 0, end )
            if ( 0 < number && number <= max )
                {
                this._prefix = prefix
                this._number = number
                return true
                }
            }
        }
    this._prefix = undefined
    this._number = undefined
    return false
    }
Linker.prototype.addBook = function( title, topic, pane )
    {
    if ( wlx.wlx_maxColumns == "AUTO" )
        {
        this.onPlus( title, topic )
        }
    else
        {
        var iReader = this._readers.length - 1
        var lastReader = this._readers[ iReader ]
        lastReader.openBook( title, undefined, topic )
        }
    }
Linker.prototype.onColumns = function( selector )
    {
    var oldcols = wlx.wlx_maxColumns
    wlx.wlx_maxColumns = this.columnSelection()
    if ( oldcols != wlx.wlx_maxColumns )
        {
        if ( wlx.wlx_maxColumns != "AUTO" )
            {
            var readers = this.numReaders()
            if ( readers < wlx.wlx_maxColumns )
                {
                this.onPlus( undefined, undefined, wlx.wlx_maxColumns )
                }
            else if ( wlx.wlx_maxColumns < readers )
                {
                this.onMinus( wlx.wlx_maxColumns )
                }
            }
        wlx.wlx_saveStateToCookie()
        }
    }
Linker.prototype.getControl = function( name )
    {
    if ( this._topPane === undefined  || this._form === undefined )
        {
        this._topPane = top_pane
        this._form = this._topPane.document[ 'topForm' ];
        }
    return this._form.elements[ name ]
    }
Linker.prototype.setColumnSelection = function( value )
    {
    wlx.wlx_maxColumns = value
    var columnsSelection = this.getControl( 'columns' );
    var index = this.selectionIndex( columnsSelection )
    var options = columnsSelection.options;
    for ( var i = 0 ; i < options.length ; ++i )
        {
        if ( options[ i ].text == value )
            {
            columnsSelection.selectedIndex = i;
            return;
            }
        }
    }
Linker.prototype.columnSelection = function()
    {
    var columnsSelection = this.getControl( 'columns' );
    var index = this.selectionIndex( columnsSelection )
    var options = columnsSelection.options;
    return options[ index ].text;
    }
Linker.prototype.selectionIndex = function( selector )
    {
    var options = selector.options;
    for ( var i = 0 ; i < options.length ; ++i )
        {
        if ( options[ i ].selected )
            {
            return i;
            }
        }
    alert( 'No selection found!' )
    }
Linker.prototype.onTextSize = function( selector )
    {
    var oldSize = wlx.wlx_textSize
    wlx.wlx_textSize = this.textSizeSelection()
    if ( oldSize != wlx.wlx_textSize )
        {
        this.restart()
        }
    }
Linker.prototype.setTextSizeSelection = function( value )
    {
    wlx.wlx_textSize = value
    var textSizeSelection = this.getControl('textsize' );
    var index = this.selectionIndex( textSizeSelection )
    var options = textSizeSelection.options;
    for ( var i = 0 ; i < options.length ; ++i )
        {
        if ( options[ i ].text == value )
            {
            textSizeSelection.selectedIndex = i;
            return;
            }
        }
    }
Linker.prototype.textSizeSelection = function()
    {
    var textSizeSelection = this.getControl( 'textsize' );
    var index = this.selectionIndex( textSizeSelection )
    var options = textSizeSelection.options;
    return options[ index ].text;
    }
Linker.prototype.reloadPanes = function( pane )
    {
    if ( pane === undefined )
        {
        pane = top
        }
    for ( var i = 0 ; i < pane.frames.length ; ++i )
        {
        var child = pane.frames[ i ]
        this.reloadPanes( child )
        }
    if ( pane !== top && pane.name != 'top_pane' )
        {
        var location = pane.location
        if ( location !== undefined )
            {
            pane.location.reload( true )
            }
        }
    }
Linker.prototype.findPane = function( name, below )
    {
    // alert( 'linker.findPane 1 ' + name + ' ' + below )
    var found = undefined;
    if ( below === undefined )
        {
        below = study
        }
    // alert( 'linker.findPane 2 ' + name + ' ' + below )
    if ( below.name == name )
        {
        found = below
        }
    // alert( 'linker.findPane 3 ' + name + ' ' + below )
    for ( 
        var i = 0 ; 
        found == undefined && 
        below.frames !== undefined &&
        i < below.frames.length ; 
        ++i 
        )
        {
        var child = below.frames[ i ]
        if ( child.name == name )
            {
            found = child
            }
        else
            {
            found = this.findPane( name, child )
            }
        }
    // alert( 'linker.findPane return ' + found )
    return found
    }
