// Blank lines and comments stripped to reduce size.
// Contact contact@SpiritAndTruth.org for commented source files.
function NavDoc( reader, name, instance, parentPane )
    {
    if ( reader !== undefined )
        {
        this._reader = reader;
        this._nameRoot = name;
        this._name = name + instance.toString();
        this._parentPane = parentPane;
        this._topicEntered = undefined;
        this._pane = this._parentPane.frames[ this._name ];
        this._doc = this._pane.document;
        this._form = this._doc[ this._nameRoot ];
        this._topicEntry = this._form.elements[ 'topicEntry' ];
        this._checkIsLocked = this._form.elements[ 'locked' ];
        this._checkIsCase = this._form.elements[ 'case' ];
        this._checkIsOT = this._form.elements[ 'ot' ];
        this._checkIsNT = this._form.elements[ 'nt' ];
        this._bookSelection = this._form.elements[ 'bookSelection' ];
        this._searchSelection = this._form.elements[ 'searchSelection' ];
        this._language = this._form.elements[ 'language' ];
        this._strongs = this._form.elements[ 'strongs' ];
        this._book = this._form.elements[ 'book' ];
        this._topic = this._form.elements[ 'topic' ];
        this._chapter = this._form.elements[ 'chapter' ];
        this._verse = this._form.elements[ 'verse' ];
        this._parentPane.navDocObject = this;
        }
    }
new NavDoc();
NavDoc.prototype.showLocation = function( topic )
    {
    if ( this._topicEntry == undefined )
       {
       return;
       }
    var human = topic.replace( /_/g, " " );
    human = human.replace( /C(\d+)V(\d+)/g, "$1:$2" );
    this._topicEntered = human;
    this._topicEntry.value = human;
    }
NavDoc.prototype.onCancel = function()
    {
    this._reader.goCancel()
    return false;
    }
NavDoc.prototype.onSubmit = function()
    {
    var topic = this._topicEntry.value;
    this.goTopic( topic )
    return false;
    }
NavDoc.prototype.onSubmitStrongs = function()
    {
    this.goStrongs()
    return false;
    }
NavDoc.prototype.onClose = function( window )
    {
    this._reader.onClose( window )
    }
NavDoc.prototype.onGoAddress = function( theEvent )
    {
    if ( theEvent != undefined && theEvent.type == 'keypress' )
        {
        if ( !wlx.wlx_linker.isMicrosoft() )
            {
            return true;
            }
        if ( theEvent.keyCode != 13 && theEvent.keyCode != 9 )
            {
            return true;
            }
        }
    var options = this._book.options;
    var i = this.selectionIndex( this._book )
    var book = options[ i ].value;
    var options = this._chapter.options;
    var i = this.selectionIndex( this._chapter )
    var chapter = options[ i ].value;
    var options = this._verse.options;
    var i = this.selectionIndex( this._verse )
    var verse = options[ i ].value;
    var to =  book + '_C' + chapter + 'V' + verse
    this.goTopic( to );
    return;
    }
NavDoc.prototype.onGoTopic = function( theEvent )
    {
    if ( theEvent != undefined && theEvent.type == 'keypress' )
        {
        if ( !wlx.wlx_linker.isMicrosoft() )
            {
            return true;
            }
        if ( theEvent.keyCode != 13 && theEvent.keyCode != 9 )
            {
            return true;
            }
        }
    var options = this._topic.options;
    var i = this.selectionIndex( this._topic )
    var topic = options[ i ].value;
    this.goTopic( topic );
    return;
    }
NavDoc.prototype.onGoStrongs = function( theEvent )
    {
    if ( theEvent != undefined && theEvent.type == 'keypress' )
        {
        if ( !wlx.wlx_linker.isMicrosoft() )
            {
            return true;
            }
        if ( theEvent.keyCode != 13 && theEvent.keyCode != 9 )
            {
            return true;
            }
        }
    this.goStrongs()
    }
NavDoc.prototype.goStrongs = function()
    {
     var language = 'Hebrew'
     var options = this._language.options;
        for ( var i = 0 ; i < options.length ; ++i )
            {
            if ( options[ i ].selected )
                {
                language = options[ i ].value;
                }
            }
    var entry = this._strongs.value;
    var strongs = entry.match( /\d+/ )
    var prefix = entry.match( /\D+/ );
    if ( strongs == null )
        {
        strongs = "1"
        }
    l = language.toLowerCase()
    l = l.charAt(0)
    if ( prefix == null );
        {
        prefix = l;
        }
    prefix = prefix.toLowerCase();
    if ( prefix != 'g' ||  prefix != 'h' )
        {
        prefix = l;
        }
    var fileNum = strongs
    remainder = fileNum % 1000
    fileNum -= remainder
    fileNum = fileNum / 1000
    this.goTopic( prefix + strongs );
    }
NavDoc.prototype.onMaximize = function( theEvent )
    {
    this._reader.onMaximize( this._parentPane );
    }
NavDoc.prototype.onClose = function( theEvent )
    {
    this._reader.onClose( this._parentPane );
    }
NavDoc.prototype.onTopicEntry = function( theEvent )
    {
    var topic = this._topicEntry.value;
    if ( theEvent.type == 'keypress' )
        {
        if ( !wlx.wlx_linker.isMicrosoft() )
            {
            return true;
            }
        if ( theEvent.keyCode != 13 && theEvent.keyCode != 9 )
            {
            return true;
            }
        }
    
    this.goTopic( topic );
    }
NavDoc.prototype.onLoad = function( theEvent )
    {
    this._reader.onLoadNavdoc()
    }
NavDoc.prototype.goTopic = function( topic )
    {
    if ( this._topicEntry != undefined )
        {
        this._pane.focus();
        this._topicEntry.select();
        this._topicEntry.focus();  // Required by Netscape, OK for IE.
        }
    if ( this._searchSelection != undefined )
        {
        var index = this.selectionIndex( this._searchSelection )
        var options = this._searchSelection.options;
        var selection = options[ index ].text;
        this._reader.goSearch(
            selection,
            topic,
            this._checkIsCase.checked,
            this._checkIsOT.checked,
            this._checkIsNT.checked
            )
        }
    if ( topic != this._topicEntered )
        {
        this._topicEntered = topic;
        this._reader.topicEntered( topic );
        }
    }
NavDoc.prototype.isLocked = function()
    {
    return this._checkIsLocked.checked;
    }
NavDoc.prototype.updateStrongsSelection = function( prefix, number )
    {
    var language = 'Hebrew';
    if (  prefix.toUpperCase() != 'H' )
        {
        language = 'Greek';
        }
    this.updateSelection( this._language, language )
    if ( this._strongs !== undefined )
        {
        this._strongs.value = number
        }
    }
NavDoc.prototype.updateTopicSelection = function( topic )
    {
    var topicLetter = topic.substr(0, 1).toUpperCase()
    if ( this._topic !== undefined )
        {
        this.updateSelection( this._topic, topicLetter )
        }
    }
NavDoc.prototype.updateBookSelection = function( title )
    {
    this.updateSelection( this._bookSelection, title )
    }
NavDoc.prototype.updateAddressSelection = function( address )
    {
    this.updateSelection( this._book, address.book() )
    this.updateSelection( this._chapter, address.chapter() )
    this.updateSelection( this._verse, address.verse() )
    }
NavDoc.prototype.updateSelection = function( selector, text )
    {
    if ( selector !== undefined )
        {
        var options = selector.options;
        if ( 
            options !== undefined && 
            options.length !== undefined &&
            options.length != '' 
            )
            {
            for ( var i = 0 ; i < options.length ; ++i )
                {
                if ( options[ i ].text == text )
                    {
                    selector.selectedIndex = i;
                    return;
                    }
                }
            }
        }
    }
NavDoc.prototype.selectionIndex = function( selector )
    {
    var options = selector.options;
    for ( var i = 0 ; i < options.length ; ++i )
        {
        if ( options[ i ].selected )
            {
            return i;
            }
        }
    alert( 'No selection found!' )
    }
NavDoc.prototype.onSelect = function( selector )
    {
    var index = this.selectionIndex( this._bookSelection )
    var options = this._bookSelection.options;
    var selection = options[ index ].text;
    if ( selection == 'MORE BOOKS...' )
        {
        top.location.replace( 'index.htm' )
        }
    else
        {
        this._reader.openBook( selection );
        }
    }
NavDoc.prototype.onForward = function( button )
    {
    this._reader.forward();
    }
NavDoc.prototype.onBack = function( button )
    {
    this._reader.back();
    }
NavDoc.prototype.onHelp = function( button )
    {
    this._reader.goHelp();
    }
NavDoc.prototype.onIndex = function( button )
    {
    this._reader.goIndex();
    }
NavDoc.prototype.onPrevBook = function( button )
    {
    this._reader.prevBook();
    }
NavDoc.prototype.onPrevChapter = function( button )
    {
    this._reader.prevChapter();
    }
NavDoc.prototype.onPrevVerse = function( button )
    {
    this._reader.prevVerse();
    }
NavDoc.prototype.onNextBook = function( button )
    {
    this._reader.nextBook();
    }
NavDoc.prototype.onNextChapter = function( button )
    {
    this._reader.nextChapter();
    }
NavDoc.prototype.onNextVerse = function( button )
    {
    this._reader.nextVerse();
    }
