// Blank lines and comments stripped to reduce size.
// Contact contact@SpiritAndTruth.org for commented source files.
wlx.wlx_dynamicNavdoc = true;
wlx.wlx_dynamicReader = true;
function Reader( name, instance, parentPane, title ) 
    {
    
    if ( parentPane !== undefined )
        {
        this._name = name + instance.toString();
        this._instance = instance
        this._pane = parentPane.frames[ this._name ];
        this._navdocPane = this._pane.frames[ 
            'navdoc' + instance.toString() 
            ];
        this._bookdocPane = this._pane.frames[ 
            'bookdoc' + instance.toString() 
            ];
        this._book;
        this._address;
        this._id;
        this._linker;
        this._history = new Array();
        this._iHistory = -1;
        this._historyActive = false;
        this._directory = wlx.wlx_getUrlDir( this._pane )
        this._navdoc = new NavDoc( this, 'navdoc', instance, this._pane );
        this._seekLast;
        this._bookIsLoaded = false
        this._navIsLoaded = false
        }
    }
new Reader();
Reader.Books = [
    wlx.wlx_KjvBible_TITLE,
    wlx.wlx_KjvsBible_TITLE,
    wlx.wlx_NasbBible_TITLE,
    wlx.wlx_NasbsBible_TITLE,
    wlx.wlx_Naves_TITLE,
    wlx.wlx_Tsk_TITLE,
    wlx.wlx_Isbe_TITLE,
    wlx.wlx_Xlinx_TITLE,
    wlx.wlx_Mh_TITLE,
    wlx.wlx_Index_TITLE,
    wlx.wlx_AsvBible_TITLE,
    wlx.wlx_YltBible_TITLE,
    wlx.wlx_Kj2kBible_TITLE,
    wlx.wlx_WebBible_TITLE,
    wlx.wlx_NetBible_TITLE,
    wlx.wlx_NkjvBible_TITLE,
    wlx.wlx_MkjvBible_TITLE,
    wlx.wlx_LitvBible_TITLE,
    wlx.wlx_SparvBible_TITLE,
    wlx.wlx_Bdb_TITLE,
    wlx.wlx_Strongs_TITLE,
    wlx.wlx_Search_TITLE,
    wlx.wlx_Help_TITLE
    ]
Reader.Ids = [
    'j',    //KjvBible_TITLE,
    'o',    //KjvsBible_TITLE,
    'b',    //NasbBible_TITLE,
    'c',    //NasbsBible_TITLE,
    'n',    //Naves_TITLE,
    't',    //Tsk_TITLE,
    'i',    //Isbe_TITLE,
    'x',    //Xlinx_TITLE,
    'm',    //Mh_TITLE,
    'z',    //Index_TITLE,
    'a',    //AsvBible_TITLE,
    'y',    //YltBible_TITLE,
    '2',    //Kj2kBible_TITLE,
    'w',    //WebBible_TITLE,
    'e',    //NetBible_TITLE,
    'j',    //NkjvBible_TITLE,
    'v',    //MkjvBible_TITLE,
    'l',    //LitvBible_TITLE,
    'p',    //SparvBible_TITLE,
    'd',    //Bdb_TITLE,
    's',    //Strongs_TITLE,
    'r',    //Search_TITLE,
    'h'     //Help_TITLE
    ]
Reader.TopicalBooks = [
    false, // KjvBible
    false, // KjvsBible
    false, // NasbBible
    false, // NasbsBible
    true,  // Naves
    false, // Tsk
    true,  // Isbe
    true,  // Xlinx
    false, // Mh
    true,  // Index
    false, // AsvBible
    false, // YltBible
    false, // Kj2kBible
    false, // WebBible
    false, // NetBible
    false, // NkjvBible
    false, // MkjvBible
    false, // LitvBible
    false, // SparvBible
    false, // Bdb
    false, // Strongs
    true,  // Search
    false  // Help
    ]
Reader.AddressableBooks = [
    true,  // KjvBible
    true,  // KjvsBible
    true,  // NasbBible
    true,  // NasbsBible
    true,  // Naves
    true,  // Tsk
    false, // Isbe
    true,  // Xlinx
    true,  // Mh
    true,  // Index
    true,  // AsvBible
    true,  // YltBible
    true,  // Kj2kBible
    true,  // WebBible
    true,  // NetBible
    true,  // NkjvBible
    true,  // MkjvBible
    true,  // LitvBible
    true,  // SparvBible
    false, // Bdb
    false, // Strongs
    false, // Search
    false  // Help
    ]
Reader.StrongableBooks = [
    false, // KjvBible
    true,  // KjvsBible
    false, // NasbBible
    true,  // NasbsBible
    false, // Naves
    false, // Tsk
    false, // Isbe
    false, // Xlinx
    false, // Mh
    false, // Index
    false, // AsvBible
    false, // YltBible
    false, // Kj2kBible
    false, // WebBible
    false, // NetBible
    false, // NkjvBible
    false, // MkjvBible
    false, // LitvBible
    false, // SparvBible
    true,  // Bdb
    true,  // Strongs
    true,  // Search
    false  // Help
    ]
Reader.prototype.index = function()
    {
    for ( var iBook = 0 ; iBook < Reader.Books.length ; iBook++ )
        {
        if ( Reader.Books[ iBook ] == this.title() )
            {
            return iBook
            }
        }
    alert( 'Unknown book: ' + title )
    return undefined
    }
Reader.prototype.isAddressable = function()
    {
    return Reader.AddressableBooks[ this.index() ]
    }
Reader.prototype.isTopical = function()
    {
    return Reader.TopicalBooks[ this.index() ]
    }
Reader.prototype.isStrongable = function()
    {
    return Reader.StrongableBooks[ this.index() ]
    }
Reader.prototype.titles = function()
    {
    return Reader.Books
    }
Reader.titleFromID = function( ids )
    {
    ids = ids.toString()
    ids = ids.substring( 0, 1 )
    for ( var i = 0 ; i < Reader.Ids.length ; ++i )
        {
        if ( ids == Reader.Ids[ i ] )
            {
            return Reader.Books[ i ]
            }
        }
    return wlx.wlx_KjvBible_TITLE
    }
Reader.prototype.openBook = function( title, lock, topic )
    {
    if( ! wlx.wlx_titlePresent( title ) )
        {
        title = wlx.wlx_KjvsBible_TITLE;
        }
    var book = this._book
    var prevTitle = undefined;
    if ( book !== undefined )
        {
        prevTitle = this._book.title()
        }
    if ( topic === undefined )
        {
        topic = this._seekLast
        }
    if ( lock === undefined )
        {
        lock = this.isLocked()
        if ( this.title() == wlx.wlx_Help_TITLE )
            {
            lock = false
            }
        }
    if ( title === undefined )
        {
        var openBooks = this._linker.openBooks();
        for ( var iBook = 0 ; iBook < Reader.Books.length ; iBook++ )
            {
            var isOpen = false;
            for ( var iOpen = 0 ; iOpen < openBooks.length ; ++iOpen )
                {
                if ( Reader.Books[ iBook ] == openBooks[ iOpen ] )
                    {
                    isOpen = true;
                    }
                }
            if ( !isOpen )
                {
                title = Reader.Books[ iBook ];
                break;
                }
            }
        }
    if ( title === undefined )
        {
        title = wlx.wlx_KjvsBible_TITLE;
        }
    if ( this._book !== undefined  && this._book.title() == title )
        {
        return;
        }
    var url;
    var urlDir;
    if ( title == wlx.wlx_Search_TITLE )
        {
        this._book = new Search();
        urlDir = this._directory + '../search/';
        url = 'search.htm';
        urlNavdoc = lock? 'navsrchl.htm' : 'navsrch.htm'
        }
    else if ( title == wlx.wlx_Xlinx_TITLE )
        {
        this._book = new Xlinx();
        urlDir = this._directory + '../xref/xlinx/';
        url = 'xlinx.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_NetBible_TITLE )
        {
        this._book = new NetBible();
        if ( wlx.wlx_NetBibleLocal )
            {
            urlDir = this._directory + '../bibles/net/';
            url = 'net.htm';
            }
        else
            {
            urlDir = 'https://www.bible.org/netbible/';
            url = 'netweb.htm';
            }
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_NkjvBible_TITLE )
        {
        this._book = new NkjvBible();
        urlDir = this._directory + '../bibles/nkjv/';
        url = 'nkjv.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_MkjvBible_TITLE )
        {
        this._book = new MkjvBible();
        urlDir = this._directory + '../bibles/mkjv/';
        url = 'mkjv.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_LitvBible_TITLE )
        {
        this._book = new LitvBible();
        urlDir = this._directory + '../bibles/litv/';
        url = 'litv.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_WebBible_TITLE )
        {
        this._book = new WebBible();
        urlDir = this._directory + '../bibles/web/';
        url = 'web.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_Tsk_TITLE )
        {
        this._book = new Tsk();
        urlDir = this._directory + '../xref/tsk/';
        url = 'tsk.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_KjvsBible_TITLE )
        {
        this._book = new KjvsBible();
        urlDir = this._directory + '../bibles/kjvs/';
        url = 'kjvs.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_NasbBible_TITLE )
        {
        this._book = new NasbBible();
        urlDir = this._directory + '../bibles/nasb/';
        url = 'nasb.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_NasbsBible_TITLE )
        {
        this._book = new NasbsBible();
        urlDir = this._directory + '../bibles/nasbs/';
        url = 'nasbs.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_KjvBible_TITLE )
        {
        this._book = new KjvBible();
        urlDir = this._directory + '../bibles/kjv/';
        url = 'kjv.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_YltBible_TITLE )
        {
        this._book = new YltBible();
        urlDir = this._directory + '../bibles/ylt/';
        url = 'ylt.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_Kj2kBible_TITLE )
        {
        this._book = new Kj2kBible();
        urlDir = this._directory + '../bibles/kj2k/';
        url = 'kj2k.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_Help_TITLE )
        {
        this._book = new Help();
        urlDir = this._directory + '../study/';
        url = 'help.htm';
        urlNavdoc = lock? 'navtpcl.htm' : 'navtpcl.htm'
        }
    else if ( title == wlx.wlx_Index_TITLE )
        {
        this._book = new Index();
        urlDir = this._directory + '../xref/index/';
        url = 'mindex.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_AsvBible_TITLE )
        {
        this._book = new AsvBible();
        urlDir = this._directory + '../bibles/asv/';
        url = 'asv.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_SparvBible_TITLE )
        {
        this._book = new SparvBible();
        urlDir = this._directory + '../bibles/sparv/';
        url = 'sparv.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_Strongs_TITLE )
        {
        this._book = new Strongs();
        urlDir = this._directory + '../dict/strongs/';
        url = 'strongs.htm';
        urlNavdoc = lock? 'navnuml.htm' : 'navnum.htm'
        }
    else if ( title == wlx.wlx_Bdb_TITLE )
        {
        this._book = new Bdb();
        urlDir = this._directory + '../dict/bdb/';
        url = 'bdb.htm';
        urlNavdoc = lock? 'navnuml.htm' : 'navnum.htm'
        }
    else if ( title == wlx.wlx_Mh_TITLE )
        {
        this._book = new Mh();
        urlDir = this._directory + '../comment/mh/';
        url = 'mh.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else if ( title == wlx.wlx_Isbe_TITLE )
        {
        this._book = new Isbe();
        urlDir = this._directory + '../dict/isbe/';
        url = 'isbe.htm';
        urlNavdoc = lock? 'navtpcl.htm' : 'navtpc.htm'
        }
    else if ( title == wlx.wlx_Naves_TITLE )
        {
        this._book = new Naves();
        urlDir = this._directory + '../xref/naves/';
        url = 'naves.htm';
        urlNavdoc = lock? 'navdocl.htm' : 'navdoc.htm'
        }
    else
        {
        alert( "Unknown book: " + title );
        this.openBook( wlx.wlx_KjvsBible_TITLE, lock, topic )
        return
        }
    if ( this._book.title() != prevTitle )
        {
        this._book.reader( this );
        this._book.setPane( this._bookdocPane );
        this._book.setUrlDir( urlDir );
        this._bookIsLoaded = false
        this._navIsLoaded = false
        this._navdocPane.location.replace( this._directory + urlNavdoc ) ;
        this._bookdocPane.location.replace( this._directory + url ) ;
        if ( topic !== undefined && topic != 'undefined' )
            {
            var address = new Address( topic );
            var isAddr = address.isValid();
            var isStrongs = this._linker.isStrongs( topic )
            var isTopic = (!isStrongs && !isAddr)
            if ( isTopic && !this.isTopical() ) topic = undefined
            if ( isAddr && !this.isAddressable() ) topic = undefined
            if ( isStrongs && !this.isStrongable() ) topic = undefined
            }
        if ( topic === undefined || topic == 'undefined' )
            {
            this._appendHistory( Reader.INTRODUCTION )
            }
        else
            {
            this._openTopic = topic
            window.setTimeout( "Reader.seekFirstTopic();", 1000)
            }
        wlx.wlx_saveStateToCookie()
        }
    }
Reader.prototype.title = function() 
    { 
    var title = undefined;
    if ( this._book !== undefined )
        {
        title = this._book.title();
        }
    return title;
    }
Reader.INTRODUCTION = 'Book_Introduction'
Reader.prototype.id = function() 
    { 
    for ( var i = 0 ; i < Reader.Ids.length ; ++ i )
        {
        if ( this._book.title() == Reader.Books[ i ] )
            {
            return Reader.Ids[ i ]
            }
        }
    alert( 'Unknown book title: cannot find prefix!' )
    return 'n'
    }
Reader.prototype.isLocked = function() 
    { 
    return this._navdoc.isLocked()
    }
Reader.prototype.navdocName = function() 
    { 
    return this._navdocPane.name;
    }
Reader.prototype.bookdocName = function() 
    { 
    return this._bookdocPane.name;
    }
Reader.prototype.bookpane = function() 
    { 
    return this._bookdocPane;
    }
Reader.prototype.pane = function() 
    { 
    return this._pane;
    }
Reader.prototype.name = function() 
    { 
    return this._name;
    }
Reader.prototype.topicEntered = function( topic ) 
    { 
    if ( this._book.title() == wlx.wlx_Search_TITLE )
        {
        this.goTopic( topic, this._navdocPane )
        }
    else
        {
        this._linker.xref( topic, this._navdocPane );
        }
    }
Reader.prototype.nextVerse = function() 
    { 
    if ( !wlx.wlx_NetBibleLocal && this._book.title() == wlx.wlx_NetBible_TITLE )
        {
        alert( "The NET Bible does not yet respond to previous/next verse commands. Use the scroll bar instead." );
        return;
        }
    if ( this._address === undefined )
        {
        this._address = new Address( 'Gen. 1:1' );
        }
    else
        {
        this._address.nextVerse();
        }
    this._linker.xref( this._address.human(), this._navdocPane );
    }
Reader.prototype.nextChapter = function() 
    { 
    if ( this._address === undefined )
        {
        this._address = new Address( 'Gen. 1:1' );
        }
    else
        {
        this._address.nextChapter();
        }
    this._linker.xref( this._address.human(), this._navdocPane );
    }
Reader.prototype.nextBook = function() 
    { 
    if ( this._address === undefined )
        {
        this._address = new Address( 'Gen. 1:1' );
        }
    else
        {
        this._address.nextBook();
        }
    this._linker.xref( this._address.human(), this._navdocPane );
    }
Reader.prototype.prevVerse = function() 
    { 
    if ( !wlx.wlx_NetBibleLocal && this._book.title() == wlx.wlx_NetBible_TITLE )
        {
        alert( "The NET Bible does not yet respond to previous/next verse commands. Use the scroll bar instead." );
        return;
        }
    if ( this._address === undefined )
        {
        this._address = new Address( 'Gen. 1:1' );
        }
    else
        {
        this._address.prevVerse();
        }
    this._linker.xref( this._address.human(), this._navdocPane );
    }
Reader.prototype.prevChapter = function() 
    { 
    if ( this._address === undefined )
        {
        this._address = new Address( 'Gen. 1:1' );
        }
    else
        {
        this._address.prevChapter();
        }
    this._linker.xref( this._address.human(), this._navdocPane );
    }
Reader.prototype.prevBook = function() 
    { 
    if ( this._address === undefined )
        {
        this._address = new Address( 'Gen. 1:1' );
        }
    else
        {
        this._address.prevBook();
        }
    this._linker.xref( this._address.human(), this._navdocPane );
    }
Reader.prototype.next = function()
    {
    if ( this._address === undefined )
        {
        this._address = new Address( 'Gen. 1:1' );
        }
    else
        {
        this._address.nextVerse();
        }
    this._linker.xref( this._address.human(), this._navdocPane );
    }
Reader.prototype.prev = function()
    {
    if ( this._address === undefined )
        {
        this._address = new Address( 'Gen. 1:1' );
        }
    else
        {
        this._address.prevVerse();
        }
    this._linker.xref( this._address.human(), this._navdocPane );
    }
Reader.prototype.containsViewer = function( pane )
    {
    return this.containsPane( pane, this._bookdocPane )
    }
Reader.prototype.containsPane = function( pane, lookBelow ) 
    {
    if ( pane.name == 'b' || pane.name == 'x' || pane.name == 'y' )
        {
        oldPane = pane
        pane = pane.parent
        }
    if ( lookBelow === undefined )
        {
        lookBelow = this._pane
        }
    if ( lookBelow === undefined )
        {
        return false
        }
    if ( lookBelow.name == pane.name )
        {
        return true
        }
    if ( wlx.wlx_NetBible_TITLE == this.title() && !wlx.wlx_NetBibleLocal )
        {
        if ( lookBelow.name == this.bookdocName() )
            {
            return false
            }
        }
    var frames = lookBelow.frames
    for ( var i = 0 ; i < frames.length ; ++i )
        {
        if ( this.containsPane( pane, frames[ i ] ) ) return true
        }
    return false
    }
Reader.prototype.link = function( linker ) 
    {
    this._linker = linker;
    linker.register( this );
    }
Reader.prototype.setSeekLast = function( seek ) 
    { 
    this._seekLast = seek
    }
Reader.prototype.seekLast = function() 
    { 
    return this._seekLast;
    }
Reader.prototype.linker = function() 
    { 
    return this._linker;
    }
Reader.prototype.goAddress = function( address, pane, ignoreLock ) 
    { 
    var forward = true
    if ( ignoreLock === undefined ) ignoreLock = false
    if ( 
        this.isLoaded() && 
        ( !this.isLocked() || ignoreLock || this.containsPane( pane ) )
        )
        {
        forward = this._book.goAddress( address, pane );
        if ( this._book.goMoved() )
            {
            this._seekLast = address.human()
            this._appendHistory( address );
            this._address = address;
            this._navdoc.updateAddressSelection( address );
            }
        }
    return forward
    }
Reader.prototype.goStrongs = function( prefix, number, pane, ignoreLock ) 
    { 
    var forward = true
    if ( ignoreLock === undefined ) ignoreLock = false
    var isOurs = this.containsPane( pane )
    if ( this.isLoaded() && ( !this.isLocked() || ignoreLock || isOurs ) )
        {
        forward = this._book.goStrongs( prefix, number, pane );
        if ( this._book.goMoved() )
            {
            this._seekLast = prefix + number
            this._appendHistory( this._seekLast );
            this._navdoc.updateStrongsSelection( prefix, number );
            }
        }
    return forward
    }
Reader.prototype.goCancel = function()
    { 
    return this._book.goCancel()
    }
Reader.prototype.goTopic = function( topic, pane, ignoreLock ) 
    { 
    var forward = true
    if ( ignoreLock === undefined ) ignoreLock = false
    if (
        this.isLoaded() && 
        ( !this.isLocked() || ignoreLock || this.containsPane( pane ) )
        )
        {
        var topicAndBook = topic.split( '|' )
        topic = topicAndBook[ 0 ].toString()
        if ( this.title() != wlx.wlx_Search_TITLE )
            {
            topic = topic.replace( /^[\!\@\#\$\%\^\&\*\(\)\+\|\\\{\}\"\'\~\`\/\:\;\<\>]/, '' );
            topic = topic.replace( / /g, '_' );
            }
        else
            {
            var KEYWORD = '_SEARCH_'
            var sx = topic.substring( 0, KEYWORD.length )
            var remainder = topic.substring( KEYWORD.length, topic.length )
            if ( sx == KEYWORD )
                {
                topic = remainder
                this.goSearch(
                    wlx.wlx_KjvsBible_TITLE,
                    topic,
                    false, // not case sensitive
                    true,  // include OT
                    true   // include NT
                    )
                }
            }
        forward = this._book.goTopic( topic, pane );
        if ( this._book.goMoved() )
            {
            this._seekLast = topic
            this._appendHistory( topic );
            this._navdoc.updateTopicSelection( topic );
            }
        }
    return forward
    }
Reader.prototype.goFootnote = function( topic, pane, ignoreLock ) 
    { 
    var forward = this._book.goFootnote( topic, pane );
    // Footnotes do not affect seeking history or update the selection.
    if ( 0 && this._book.goMoved() )
        {
        this._seekLast = topic
        this._appendHistory( topic );
        this._navdoc.updateTopicSelection( topic );
        }
    return forward
    }
Reader.prototype.onMaximize = function( pane ) 
    { 
    this._linker.onMaximize( pane )
    }
Reader.prototype.onClose = function( pane ) 
    { 
    this._linker.onClose( pane )
    }
Reader.prototype.isLoaded = function() 
    { 
    return ( 
        this._bookIsLoaded && 
        this._navIsLoaded  &&
        this._book.isLoaded()
        )
    }
Reader.prototype.onLoad = function( pane ) 
    { 
    if ( pane == this._bookdocPane ) 
        {
        this._bookIsLoaded = true
        }
    if ( pane == this._navdocPane ) 
        {
        this._navIsLoaded = true
        }
    this._book.onLoad( pane );
    }
Reader.seekFirstTopic = function()
    {
    var done = true
    var readers = wlx.wlx_linker.getReaders();
    for ( var i = 0 ; i < readers.length ; ++i )
        {
        var reader = readers[ i ];
        var topic = reader._openTopic
        if ( topic != undefined )
            {
            if( reader.isLoaded() )
                {
                reader._openTopic = undefined
                wlx.wlx_linker.xref( topic, reader.pane(), true )
                reader._historyActive = false
                }
            else
                {
                done = false
                 
                }
            }
        }
    if ( !done )
        {
        window.setTimeout( "Reader.seekFirstTopic();", 500)
        }
    }
Reader.prototype.onLoadNavdoc = function() 
    { 
    this._navIsLoaded  = true
    this._navdoc = new NavDoc( this, 'navdoc', this._instance, this._pane );
    this._navdoc.updateBookSelection( this._book.title() );
    }
Reader.prototype.goFile = function( fileWithAnchor ) 
    {
    return this._book.goFile( fileWithAnchor )
    }
Reader.prototype.forward = function() 
    {
    this._forwardHistory();
    }
Reader.prototype.back = function() 
    {
    this._backHistory();
    }
Reader.prototype.goHelp = function() 
    {
    return this.goTopic( Reader.INTRODUCTION, this._bookdocPane )
    }
Reader.prototype.goIndex = function() 
    {
    this._seekLast = undefined
    wlx.wlx_saveStateToCookie()
    return this._book.goIndex();
    }
Reader.prototype.showLocation = function( location )
    {
    var show = location.split( '|' )
    return this._navdoc.showLocation( show[ 0 ] )
    }
Reader.prototype._appendHistory = function( addressOrTopic )
    {
    var location = addressOrTopic;
    if ( Address.is( addressOrTopic ) )
        {
        location = addressOrTopic.human();
        }
    this.showLocation( location );
    if ( this._historyActive )
        {
        return;
        }
    location += '|'  + this.id()
    this._iHistory += 1;
    this._history[ this._iHistory ] = location;
    this._history.length = this._iHistory + 1
    wlx.wlx_saveStateToCookie()
    }
Reader.prototype._backHistory = function()
    {
    if ( 0 < this._iHistory )
        {
        this._iHistory -= 1;
        this._currentHistory( false );
        }
    }
Reader.prototype._forwardHistory = function()
    {
    if ( this._iHistory < this._history.length - 1 )
        {
        this._iHistory += 1;
        this._currentHistory( false );
        }
    }
Reader.prototype._currentHistory = function( alone )
    {
    this._goHistory( this._history[ this._iHistory ], alone );
    }
Reader.prototype._goHistory = function( topicAndBook, alone )
    {
    if ( topicAndBook === undefined )
        {
        return;
        }
    if ( alone === undefined )
        {
        alone = false
        }
    this._historyActive = true;
    var parts = topicAndBook.split( '|' )
    var topic = parts[ 0 ]
    var id = undefined
    if ( 1 < parts.length )
        {
        id = parts[ 1 ]
        }
    if ( topic == Reader.INTRODUCTION  && id == this.id() )
        {
        alone = true
        }
    historyActive = ( !alone && id !== undefined && id != this.id() )
    if ( alone )
        {
        var address = new Address( topic )
        if ( address.isValid() )
            {
            this.goAddress( address, this._navdocPane, true );
            }
        else
            {
            this.goTopic( topic, this._navdocPane, true );
            }
        }
    else
        {
        if ( id != this.id() )
            {
            this.openBook( Reader.titleFromID( id ), this.isLocked(), topic )
            }
        this._linker.xref( topicAndBook, this._navdocPane );
        }
    this._historyActive = historyActive
    if ( this._historyActive )
        {
        }
    }
Reader.prototype.numReaders = function( )
    {
    return this._linker.numReaders()
    }
Reader.prototype.goSearch = function( 
    titleToSearch,
    searchCriteria,
    isCase,
    isOT,
    isNT
    ) 
    {
    this._seekLast = searchCriteria
    this._appendHistory( searchCriteria );
    return this._book.goSearch(
        titleToSearch,
        searchCriteria,
        isCase,
        isOT,
        isNT
        )
    }
