// Blank lines and comments stripped to reduce size.
// Contact contact@SpiritAndTruth.org for commented source files.
function Search() 
    {
    this._searchTitle;
    this._target;
    this._isCase;
    this._isOT;
    this._isNT;
    this._files = new Array()
    this._iFile = 0
    this._address = new Address( 'Gen. 1:1' )
    this._inProgress = false;
    this._isCancelled = false;
    this._noNOT = true
    this._matchBookVerses;     // Array of matched verses in that book.
    this._matchBookAddresses;  // Array of corresponding addresses.
    this._matchBookNames;      // Corresponding book names.
    this._matchCount;
    this._matchBookExpanded;   // True for each book that is expanded view.
    this._matchAddresses;
    this._matchVerses;
    this._matchStrongs;
    this._matchStrongsWords;
    this._matchStrongsWordsCounts;
    this._args;     // words, phrases, operators
    this._argsIsOp; // operator, not word or phrase
    this._isHebrew; // contains Hebrew Strong's numbers
    this._isGreek;  // contains Greek Strong's numbers
    this._noLanguage;
    this._textHasLanguage;
    }
Search._files = new Array();
new Search();
wlx.wlx_Search_TITLE = 'Search';
Search.prototype = new Book( wlx.wlx_Search_TITLE, Search._files );
Search.prototype.goHelp = function()
    {
    
    var instance = this._reader._instance;
    wlx.wlx_match[ instance ] = undefined 
    this.goFile( '../study/search.htm' );
    }
Search.prototype.goIndex = function()
    {
    this.goFile( 'go.htm' );
    }
Search.prototype.goTopicUnconditional = function( topic, pane )
    {
    this.setGoMoved( true )
    return false
    }
Search.prototype.goStrongsUnconditional = function( prefix, number, pane )
    {
    this.setGoMoved( true )
    return false
    }
Search.prototype.goSearch = function( 
    searchTitle,
    target,
    isCase,
    isOT,
    isNT
    ) 
    { 
    if ( this._inProgress )
       {
       return
       }
    this._inProgress = true;
    this._isCancelled = false;
    this._noNOT = true
    this._instance = this._reader._instance;
    this._matchStrongs = new Array();
    this._matchStrongsWords = new Array();
    this._matchStrongsWordsCounts = new Array();
    this._matchBookVerses = new Array();
    this._matchBookAddresses = new Array();
    this._matchBookNames = new Array();
    this._matchBookExpanded = new Array();
    this._matchVerses = new Array();
    this._matchAddresses = new Array();
    this._matchCount = 0
    if ( wlx.wlx_match === undefined )
        {
        wlx.wlx_match = new Array()
        }
    wlx.wlx_match[ this._instance ] = new Array()
    this._matchInfo = wlx.wlx_match[ this._instance ]
    this._matchInfo[ 'COUNT' ] = 0
    this._matchInfo[ 'PERCENT' ] = undefined
    this._iLine = 0
    var suffix = new Array();
    var prefix;
    this._searchTitle = searchTitle
    this._target = target
    this._isCase = isCase
    this._isOT = isOT
    this._isNT = isNT
    var iStart = 0
    var iEnd = 0
    target = target.replace( 'a', 'a' )
    target = target.replace( /\*/g, '\\w*' )
    target = target.replace( /\?/g, '\\w' )
    target = target.replace( /\(/g, ' ( ' )
    target = target.replace( /\)/g, ' ) ' )
    var openCount = 0
    for ( var i = 0 ; 0 <= openCount && i < target.length ; ++i )
        {
        var c = target[ i ]
        if ( c == '(' )
           {
           openCount++
           }
        else if ( c == ')' )
           {
           openCount--
           }
        }
    if ( openCount != 0 )
        {
        alert( 'Mismatched parenthesis!' )
        this._inProgress = false
        return
        }
    var iPhrase;
    var iNext = 0
    var newTarget = ''
    var phraseTarget = target.replace( /[\"\']/g, '"' )
    var phraseFound = false
    while( ( iPhrase = phraseTarget.indexOf( '"', iNext ) ) != -1 )
        {
        var iPhraseEnd = phraseTarget.indexOf( '"', iPhrase + 1 )
        if ( -1 == iPhraseEnd )
            {
            alert( 'Missing closing quote: ' + phraseTarget )
            this._inProgress = false
            return
            }
        phraseFound = true
        newTarget += target.slice( 0, iPhrase ) + ' '
        var phrase = phraseTarget.slice( iPhrase+1, iPhraseEnd )
        phrase = phrase.replace( / +/g, '\\s' )
        newTarget += phrase + ' '
        iNext = iPhraseEnd + 1
        }
    newTarget += target.slice( iNext, target.length )
    target = newTarget
    target = target.replace( /^ +/, '' )
    target = target.replace( / +$/, '' )
    target = target.replace( /  /g, ' ' )
    this._args = target.split( ' ' )
    if ( !this._isCase )
        {
        for ( var i = 0 ; i < this._args.length ; ++i )
            {
            var arg = this._args[ i ]
            if ( arg != 'AND' && arg != 'OR' && arg != 'NOT' )
                {
                this._args[ i ] = arg.toLowerCase()
                }
            }
        }
    this._noLanguage = true
    this._isGreek = false
    this._isHebrew = false
    var allStrongs = true
    this._argsIsOp = new Array()
    for ( var iWord = 0 ; iWord < this._args.length ; ++iWord )
        {
        var word = this._args[ iWord ]
        var isOp = ( word == 'AND' || word == 'OR' || word == 'NOT' || word == '(' || word == ')' )
        this._argsIsOp[ iWord ] = isOp
        if ( isOp  && word == 'NOT' )
            {
            this._noNOT = false
            }
        var iHebrew = word.search( '^h\\d+' )
        var iGreek = word.search( '^g\\d+' )
        if ( 0 == iHebrew )
            {
            this._noLanguage = false
            this._isHebrew = true
            this._isOT = true
            }
        else if ( 0 == iGreek )
            {
            this._noLanguage = false
            this._isGreek = true
            this._isNT = true
            }
        else
            {
            allStrongs = allStrongs && isOp
            }
        if ( !isOp )
            {
            this._args[ iWord ] = '\\b' + word + '\\b'
            }
        }
    if ( phraseFound && !this._noLanguage )
        {
        alert( 'Can\'t mix phrases and Strong\'s numbers in the same search!' )
        this._inProgress = false
        return
        }
    if ( allStrongs )
        {
        this._isOT =  this._isHebrew
        this._isNT =  this._isGreek
        }
    var OTFILES = 6
    var NTFILES = 2
    if ( 
        this._searchTitle == wlx.wlx_KjvsBible_TITLE ||
        this._searchTitle == wlx.wlx_Kj2kBible_TITLE ||
        this._searchTitle == wlx.wlx_NkjvBible_TITLE ||
        this._searchTitle == wlx.wlx_WebBible_TITLE
        )
        {
        this._textHasLanguage = ( this._searchTitle == wlx.wlx_KjvsBible_TITLE )
        iPrefix = 3
        if ( 
            this._searchTitle == wlx.wlx_Kj2kBible_TITLE ||
            this._searchTitle == wlx.wlx_NkjvBible_TITLE
            )
            {
            iPrefix = 4
            }
        // Special case where title and file prefix mismatch.
        if ( this._searchTitle == wlx.wlx_Kj2kBible_TITLE )
            {
            this._searchTitle = 'kj2k'
            }
        prefix = this._searchTitle.slice( 0, iPrefix )
        prefix = prefix.toLowerCase()
        this._allLines = 0
        if ( this._isOT )
            {
            this._address = new Address( 'Gen. 1:1' )
            this._allLines += 23145
            for ( var i = 0 ; i < OTFILES ; i++ )
                {
                suffix[ suffix.length ] = 'ot' + i
                }
            }
        else
            {
            this._address = new Address( 'Mat. 1:1' )
            }
        if ( this._isNT )
            {
            this._allLines += 7957
            for ( var i = 0 ; i < NTFILES ; i++ )
                {
                suffix[ suffix.length ] = 'nt' + i
                }
            }
        }
    else
        {
        alert( this._searchTitle + ' does not yet support searching. Sorry.' )
        this._inProgress = false;
        return
        }
    if ( !this._textHasLanguage && ( this._isGreek || this._isHebrew ) )
        {
        alert( 'Only the ' + wlx.wlx_KjvsBible_TITLE + ' can search on Strong\'s numbers.')
        this._inProgress = false
        return
        }
    this._files = new Array()
    this._iFile = -1
    for ( var iSuffix = 0 ; iSuffix < suffix.length ; ++iSuffix )
        {
        this._files[ iSuffix ] = prefix + suffix[ iSuffix ] + '.htm'
        }
    if ( 0 < this._args.length )
        {
        var file = this.urlDir() + 'searching.htm'
        this.pane().sb.location.replace( file )
        this.onLoad( this.pane().sx )
        }
    else
        {
        alert( 'Nothing to search for?' )
        }
    }
Search.prototype.onLoad = function( pane )
    {
    if ( pane != this.pane().sx )
        {
        this.BOOK_onLoad( pane )
        return
        }
    if ( 
        this._inProgress && 
        !this._isCancelled &&
        this._iFile < this._files.length 
        )
        {
        if ( 0 <= this._iFile )
            {
            var doc = this.pane().sx.document
            var form = doc[ 'search' ]
            var element = form.elements[ 'contents' ]
            var info;
            if ( this._textHasLanguage && this._noLanguage )
                {
                info = (element.value).replace( /<[gh]\d+>/g, '' )
                }
            else
                {
                info = element.value
                }
            var iStart = 0
            var searches = new Array()
            var iSearches = new Array()
            var matchList = new Array();
            var indexList = new Array();
            while ( true && !this._isCancelled )
                {
                var iEnd = info.indexOf( '\n', iStart )
                if ( -1 == iEnd )
                    {
                    break
                    }
                var verse = info.slice( iStart, iEnd )
                var searchVerse;
                if ( this._isCase )
                    {
                    searchVerse = verse
                    }
                else
                    {
                    searchVerse = verse.toLowerCase()
                    }
                var wordsMatched = 0
                var wordsSearched = 0
                searches.length = 0
                iSearches.length = 0
                for ( iWord = 0 ; iWord < this._args.length ; ++iWord )
                    {
                    if ( this._argsIsOp[ iWord ] ) continue
                    if ( matchList.length != 0 )
                        {
                        matchList = new Array();
                        indexList = new Array();
                        }
                    wordsSearched += 1
                    var word = this._args[ iWord ]
                    var iRemainder = 0;
                    var iMatch;
                    var remainder = searchVerse
                    while ( 0 <= ( iMatch = remainder.search( word ) ) )
                        {
                        var matched = remainder.match( word )
                        var iAbsolute = iRemainder + iMatch
                        iRemainder = iAbsolute + matched[ 0 ].length
                        remainder = searchVerse.substring( iRemainder, searchVerse.length )
                        matchList[ matchList.length ] = matched
                        indexList[ indexList.length ] = iAbsolute
                        }
                    if ( matchList.length )
                        {
                        searches[ iWord ]  = matchList
                        iSearches[ iWord ] = indexList
                        wordsMatched += matchList.length
                        }
                    }
                if ( this.evalMatch( searches ) )
                    {
                    this._matchCount += 1
                    this._matchVerses[ this._matchVerses.length ] = this.formatVerse( searches, iSearches, verse )
                    this._matchAddresses[ this._matchAddresses.length ] = this._address.anchor()
                    }
                iStart = iEnd + 1
                this._iLine += 1
                var oldBook = this._address.bookNameLong()
                this._address.nextVerse()
                var newBook = this._address.bookNameLong()
                if ( oldBook != newBook )
                    {
                    this.saveBookData( oldBook )
                    }
                }
            }
        var percent = ( this._iLine * 100 ) / this._allLines
        percent -= ( percent % 1 )
        this._matchInfo[ 'PERCENT' ] = percent
        this._matchInfo[ 'CURRENTBOOK' ] = newBook
        this._matchInfo[ 'COUNT' ] = this._matchCount

        var loadingPane = this.pane()
        if (loadingPane.sb !== undefined) loadingPane = loadingPane.sb
        var file = this.urlDir() + 'searching.htm'
        loadingPane.location.replace( file )
        
        this._iFile += 1
        if ( this._iFile < this._files.length && !this._isCancelled )
            {
            var file = this.urlDir() + this._files[ this._iFile ]
            // alert( 'DEBUG next file ' + file )
            this.pane().sx.location.replace( file )
            }
        else
            {
            this.endSearch()
            }
        }
    else
        {
        this.endSearch()
        }
    }
Search.prototype.endSearch = function()
    {
    var book = this._address.bookNameLong()
    this.saveBookData( book )
    this._matchInfo[ 'CURRENTBOOK' ] = book
    this._matchInfo[ 'BOOKNAMES' ] = this._matchBookNames
    this._matchInfo[ 'BOOKEXPANDED' ] = this._matchBookExpanded
    this._matchInfo[ 'BOOKVERSES' ] = this._matchBookVerses
    this._matchInfo[ 'BOOKADDRESSES' ] = this._matchBookAddresses
    this._matchInfo[ 'COUNT' ] = this._matchCount
    this._matchInfo[ 'TARGET' ] = this._target
    this._matchInfo[ 'STRONGS' ] = this._matchStrongs;
    this._matchInfo[ 'STRONGSWORDS' ] = this._matchStrongsWords;
    this._matchInfo[ 'STRONGSWORDSCOUNTS' ] = this._matchStrongsWordsCounts;
    this._matchInfo[ 'BOOKOPENED' ] = undefined
    this._matchInfo[ 'BOOKOPENEDINDEX' ] = undefined
    this._inProgress = false
    this._iFiles = new Array()
    this._iFile = -1
    var file = this.urlDir() + 'loading.htm'
    var resultFile = this.urlDir() + 'results.htm'
    this.pane().sx.location.replace( file )
    this.pane().sb.location.replace( resultFile )
    }
Search.prototype.evalMatch = function( searches )
    {
    if ( searches.length == 0 && this._noNOT ) return false
    var operators = new Array()
    var operands = new Array()
    for ( var iArg = 0 ; iArg < this._args.length ; ++iArg )
        {
        var isOp = this._argsIsOp[ iArg ]
        var found = ( searches[ iArg ] !== undefined )
        var arg = this._args[ iArg ]
        if ( isOp && arg != '(' && arg != ')' )
            {
            operators[ operators.length ] = arg
            }
        else
            {
            if ( arg == '(' )
                {
                operands[ operands.length ] = arg
                continue
                }
            if ( arg == ')' )
                {
                var iTop = operands.length - 1
                var opnd = operands[ iTop ]
                var p = operands[ iTop - 1 ]
                operands.length = iTop - 1
                if ( p != '(' )
                    {
                    alert( 'Empty or mismatched parenthesis!' )
                    found = false
                    }
                else
                    {
                    found = opnd
                    }
                }
            if ( operands[ operands.length - 1 ] == '(' )
                {
                operands[ operands.length ] = found
                continue
                }
            if ( 0 == operators.length && 0 < operands.length )
                {
                operators[ operators.length ] = 'AND'
                }
            found = this.evalOp( operators, operands, found )
            operands[ operands.length ] = found
            }
        }
        return operands[ 0 ]
    }
Search.prototype.evalOp = function( operators, operands, found )
    {
    if ( 0 < operators.length )
        {
        var iTop = operators.length - 1
        var op = operators[ iTop ]
        if ( op != '(' )
            {
            operators.length = iTop
            if ( op == 'AND' )
                {
                var iTop = operands.length - 1
                var other = operands[ iTop ]
                operands.length = iTop
                found = found && other
                }
            else if ( op == 'OR' )
                {
                var iTop = operands.length - 1
                var other = operands[ iTop ]
                operands.length = iTop
                found = found || other
                }
            else if ( op == 'NOT' )
                {
                found = !found
                found = this.evalOp( operators, operands, found )
                }
            else
                {
                alert( 'Unknown operator: ' + op )
                }
            }
        }
    return found
    }
Search.prototype.saveBookData = function( bookname )
    {
    if ( this._matchVerses !== undefined && this._matchVerses.length )
        {
        var names = this._matchBookNames
        var index = names.length
        if ( names.length != 0 && names[ names.length - 1 ] == bookname )
            {
            index = names.length - 1
            }
        this._matchBookNames[ index ] = bookname
        var verses = new Array()
        var addresses = new Array()
        for ( var i = 0 ; i < this._matchVerses.length ; ++i )
            {
            verses[ verses.length ] = this._matchVerses[ i ]
            addresses[ addresses.length ] = this._matchAddresses[ i ]
            }
        this._matchBookVerses[ index ] = verses
        this._matchBookAddresses[ index ] = addresses
        this._matchBookExpanded[ index ] = false
        }
    this._matchVerses.length = 0
    this._matchAddresses.length = 0
    }
Search.prototype.goCancel = function()
    {
    this._isCancelled = true
    this.endSearch()
    }
Search.prototype.formatVerse = function( searches, iSearches, verse )
    {
    var output = ''
    var iStart = 0
    var matches = new Array()
    var indexes = new Array()
    for ( var i = 0 ; i < searches.length ; ++i )
        {
        var words = searches[ i ]
        if ( words !== undefined )
            {
            var iWords = iSearches[ i ]
            for ( var j = 0 ; j < words.length ; ++j )
                {
                matches[ matches.length ] = words[ j ]
                indexes[ indexes.length ] = iWords[ j ]
                }
            }
        }
    var swapped = true
    while ( swapped )
        {
        swapped = false
        for ( var i = 0 ; i < matches.length - 1 ; ++i )
            {
            if ( indexes[ i + 1 ] < indexes[ i ] )
                {
                var temp  = matches[ i ]
                var iTemp = indexes[ i ]
                matches[ i ] = matches[ i + 1 ]
                indexes[ i ] = indexes[ i + 1 ]
                matches[ i + 1 ]  = temp
                indexes[ i + 1 ] = iTemp
                swapped = true
                }
            }
        }
    if ( this._isHebrew || this._isGreek )
        {
        verse = verse.replace( /</g, '(' )
        verse = verse.replace( />/g, ')' )
        }
    var formatted = '';
    var iNextArg = 0;
    for ( var i = 0 ; i < matches.length ; ++i )
        {
        var iStartArg = indexes[ i ]
        var phrase = matches[ i ].toString()
        var iEndArg = iStartArg + phrase.length
        if ( this._isHebrew || this._isGreek )
            {
            if ( 0 == phrase.search( '[gh]\\d+' ) )
                {
                iStartStrongs = iStartArg
                iEndStrongs = iEndArg
                iEndWord = iStartArg - 1
                iEndArg += 1
                iStartArg = verse.lastIndexOf( ' ', iStartArg )
                iStartWord = iStartArg
                if ( iStartArg < 0 )
                    {
                    iStartArg = 0
                    }
                else
                    {
                    iStartArg += 1
                    }
                if ( true )
                    {
                var word = verse.slice( iStartWord, iEndWord )
                word = word.toLowerCase()
                var strongs = verse.slice( iStartStrongs, iEndStrongs )
                var oldStrongs = this._matchStrongs[ strongs ]
                if ( oldStrongs === undefined )
                    {
                    this._matchStrongs[ this._matchStrongs.length ] = strongs
                    this._matchStrongs[ strongs ] = strongs
                    this._matchStrongsWords[ strongs ] = new Array()
                    this._matchStrongsWordsCounts[ strongs ] = new Array()
                    }
                var counts = this._matchStrongsWordsCounts[ strongs ]
                var words = this._matchStrongsWords[ strongs ]
                var count = counts[ word ]
                if ( count === undefined )
                    {
                    words[ words.length ] = word
                    count = 0
                    }
                count = count + 1
                counts[ word ] = count
                    } // END NEUTERED
                }
            }
        formatted = formatted + verse.slice( iNextArg, iStartArg )
        formatted = formatted + '<B>'
        formatted = formatted + verse.slice( iStartArg, iEndArg )
        formatted = formatted + '</B>'
        iNextArg = iEndArg
        }
    formatted = formatted + verse.slice( iNextArg, verse.length )
    return formatted
    }
